protocol Item {
    var name: String { get }
}

protocol WebContent {
    var url: String { get }
}

extension Item where Self : WebContent {
    var description: String {
        return "商品名: \(name)、 URL: \(url)"
    }
}

struct EBook: Item, WebContent {
    let name: String
    let url: String
}

struct Book: Item {
    let name: String
}

let eBook = EBook(name: "Swift実践入門", url: "https://example.com")
eBook.description // "商品名: Swift実践入門、 URL: https://example.com"

let book = Book(name: "Swift実践入門")
// Book型はWebContentプロトコルに準拠していないため、
// descriptionプロパティを利用できない
// book.description // コンパイルエラー